#include <stdio.h>
#include <stdlib.h>

typedef struct {int hh, mm;} orario;

orario leggi_orario(char *s) {
    // Preparo una struttura per il risultato
    orario res;
    // Leggo minuti ed ore
    if(sscanf(s, "%d:%d", &res.hh, &res.mm) != 2) {
        printf("Errore nella lettura dell'orario \"%s\"\n", s);
        exit(1);
    }
    // Se la lettura ha successo, restituisco il risultato
    return res;
}

orario somma_orari(orario o1, orario o2) {
    // Calcolo la somma dei minuti
    int smm = o1.mm + o2.mm;
    // Calcolo il riporto
    int rhh = smm / 60; // divisione
    // Preparo una struttura per il risultato
    orario res;
    res.mm = smm % 60;
    res.hh = (o1.hh + o2.hh + rhh) % 24;
    // Restituisco il risultato
    return res;
}


int main(int argc, char *argv[]) {
    // Preparo un accumulatore (un orario!)
    orario s;
    s.hh = 0;
    s.mm = 0;
    // Considero gli argomenti ad uno ad uno
    orario t;
    for(int i = 1; i < argc; ++i) {
        // Provo a tradurre la stringa in un orario
        t = leggi_orario(argv[i]);
        // Sommo l'orario
        s = somma_orari(s, t);
    }
    // Stampo il risultato
    printf("Risultato = %02d:%02d\n", s.hh, s.mm);   
}
